# DEMYSTIFYING THE TOKEN DYNAMICS OF DEEP SELECTIVE STATE SPACE MODELS

## Wikitext-103 experiments

### Setup environment: 
- Install pytorch==2.2.0 with cuda 12.1
- Install flash-attention
- Other packages are listed in requirements.txt

### Run Mamba with different scenarios
To run the WikiText-103 experiments, run:

> CUDA_VISIBLE_DEVICES=0,1,2,3 python -m train experiment=wt103/mamba_pos  # for positive-eigenvalues scenario
> CUDA_VISIBLE_DEVICES=0,1,2,3 python -m train experiment=wt103/mamba_neg  # for negative-eigenvalues scenario
> CUDA_VISIBLE_DEVICES=0,1,2,3 python -m train experiment=wt103/mamba_real  # for mixed-eigenvalue scenario


## Image Classification Experiments

### Setup environment
- Install pytorch==2.2.0 with cuda 12.1
- Other library are listed in requirements.txt
- Download ImageNet-1K from [here](https://image-net.org/download.php) and change the data-dir path in this [script](mambavision/train.sh) accordingly

### Run MambaVision + Reordering tokens

> cd mambavision

> bash train.sh
